// Ordi.cpp: implementation of the COrdi class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "search.h"
#include "Ordi.h"
#include "xml.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

COrdi::COrdi()
{
	id = _T("");
	ip = _T("");
	point.x = 0;
	point.y = 0;
	select = false;

	suivant = NULL;
}

COrdi::~COrdi()
{
}

COrdi& COrdi::operator = (COrdi &ordi)
{
	id = ordi.id;
	ip = ordi.ip;
	point = ordi.point;
	select = ordi.select;
	suivant = ordi.suivant;
	user = ordi.user;
	return *this;
}

COrdi::COrdi(COrdi &ordi)
{
	*this = ordi;
}

void COrdi::InitOrdiXML(FILE *fxml, char *ligne)
{
	ip = getTagValue(ligne);
	id = getAttValue(ligne, "id");
	char posX[20], 
		 posY[20];
	strcpy(posX,getAttValue(ligne, "posX"));
	strcpy(posY,getAttValue(ligne, "posY"));
	
	if (posX[0]) sscanf(posX, "%d", &(point.x));
	if (posY[0]) sscanf(posY, "%d", &(point.y));
}
