// searchDlg.cpp : implementation file
//

#include "stdafx.h"
#include "process.h"
#include "search.h"
#include "searchDlg.h"
#include "Local.h"
#include "user.h"
#include <time.h>
#include "InfoPerso.h"	// Added by ClassView


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();
	
	InfoPerso infoperso;
	// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	CString	m_URL;
	CString	m_context;
	CString	m_matricule;
	CString	m_nomcomplet;
	CString	m_ordi;
	CString	m_repertoire;
	CString	m_station;
	//}}AFX_DATA
	
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL
	
	// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	infoperso.GetEnv();
	//{{AFX_DATA_INIT(CAboutDlg)
	m_URL = _T("http://www.multimania.com/yansanmo/informat/telechar.htm");
	m_context    = infoperso.context;
	m_matricule  = infoperso.matricule;
	m_nomcomplet = infoperso.nomcomplet;
	m_ordi       = infoperso.ordi;
	m_repertoire = infoperso.repertoire;
	m_station    = infoperso.station;
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	DDX_Text(pDX, IDC_ADRESSEWEB, m_URL);
	DDX_Text(pDX, IDC_CONTEXT, m_context);
	DDX_Text(pDX, IDC_MATRICULE, m_matricule);
	DDX_Text(pDX, IDC_NOMCOMPLET, m_nomcomplet);
	DDX_Text(pDX, IDC_ORDI, m_ordi);
	DDX_Text(pDX, IDC_REPERTOIRE, m_repertoire);
	DDX_Text(pDX, IDC_STATION, m_station);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
//{{AFX_MSG_MAP(CAboutDlg)
// No message handlers
//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSearchDlg dialog

CSearchDlg::CSearchDlg(CWnd* pParent /*=NULL*/)
: CDialog(CSearchDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSearchDlg)
	texte = _T("");
	message = _T("");
	m_histo = _T("");
	send = FALSE;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(/*IDI_ICON1 */IDR_MAINFRAME );

	position.SetRect(558, 337, 732, 441);
}

void CSearchDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSearchDlg)
	DDX_Control(pDX, IDC_LISTE, context);
	DDX_Control(pDX, IDC_LISTELOCAL, local);
	DDX_Control(pDX, IDC_GRPLIST, m_grplist);
	DDX_Control(pDX, IDC_LIST1, m_listctrl);
	DDX_Control(pDX, IDC_HISTORIQUE, m_histo_ctrl);

	DDX_Text(pDX, texte1, texte);
	DDX_Text(pDX, IDC_EDIT1, message);
	DDV_MaxChars(pDX, message, 80);
	DDX_Text(pDX, IDC_HISTORIQUE, m_histo);
	DDX_Check(pDX, IDC_CHECK1, send);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CSearchDlg, CDialog)
//{{AFX_MSG_MAP(CSearchDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BTNENVOYER, OnBtnEnvoyer)
	ON_BN_CLICKED(IDC_BUTTON2, OnBtnClickMiseAJour)
	ON_BN_CLICKED(IDC_CHECK1, OnChkRecevoirOnOff)
	ON_BN_CLICKED(cmdTrouver, cmdTrouver_Click)
	ON_BN_CLICKED(IDC_PLUS, OnClickSurPlus)
	ON_BN_CLICKED(IDC_SUPPRIMERHISTO, OnBtnSupprimerhisto)
	ON_NOTIFY(LVN_COLUMNCLICK, IDC_LIST1, OnColumnclickList1)
	ON_BN_CLICKED(IDC_GRPPLUS, OnGrpplus)
	ON_BN_CLICKED(IDC_GRPMOINS, OnGrpmoins)
	ON_NOTIFY(NM_SETFOCUS, IDC_LIST1, OnSetfocusListCtrl)
	ON_NOTIFY(NM_SETFOCUS, IDC_GRPLIST, OnSetfocusGrplist)
	ON_BN_CLICKED(IDC_BUTTON1, OnBtnSauvegarder)
	ON_COMMAND(ID_PREFERENCE, OnPreference)
	ON_NOTIFY(LVN_ENDLABELEDIT, IDC_GRPLIST, OnEndlabeleditGrplist)
	ON_COMMAND(IDM_POINTINTERROGATION, OnPointinterrogation)
	ON_COMMAND(ID_MNUPLAN, OnMnuplan)
	ON_COMMAND(ID_RECHERCHER, OnMnuRechercher)
	ON_BN_CLICKED(IDC_PLUSDROITE, OnPlusdroite)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSearchDlg message handlers
BOOL CSearchDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	// Add "About..." menu item to system menu.

/*	HICON btn_hIcon = AfxGetApp()->LoadIcon(IDI_ICOBAS);
	if (btn_hIcon) 
		m_PlusBas.SetIcon(btn_hIcon); */

	CRect WinRect, rect2;
	GetWindowRect(WinRect);
	GetClientRect(rect2);

//	MoveWindow(WinRect.left, WinRect.top, rect2.right-168, rect2.bottom-79, TRUE);

	//--------------------------------------

	infoperso.GetEnv();
	OnInitInterface();
	OnInitList();
	OnInitLocaux();
	GrpListCharger();
	Lister();
	UpdateData(false);
	if (userpref.bPlusBas) EcrireHisto();

	
	
	//-------------------------------------
	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);
	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
			strAboutMenu.LoadString(ID_PREFERENCE);
			pSysMenu->AppendMenu(MF_STRING, ID_PREFERENCE, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CSearchDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		if (nID == ID_PREFERENCE)
			OnPreference();
		else
			CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CSearchDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting
		
		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);
		
		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;
		
		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CSearchDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CSearchDlg::OnBtnEnvoyer() 
{
	// TODO: Add your control notification handler code here
	CString strText;
	CString numero;
	int i;
	char tmpbuf[128], tmpbuf2[128];
	char tmp[4];
	
	CString vrai_context = GetContext();
	
	POSITION pos;
	if (listselect) pos = m_listctrl.GetFirstSelectedItemPosition();
	else            pos = m_grplist.GetFirstSelectedItemPosition();


	User user;
	char chaine[255];
	CString messageTemp;
	CString nom;

	CDataExchange DX (this, true);
	DDX_Text(&DX, IDC_EDIT1, message);
	DX.m_bSaveAndValidate = false;
	if (message.GetLength())
	{
		FILE *f;
		f = fopen("journal.log", "at");
		while (pos)
		{
			if (listselect) 
			{
				i = m_listctrl.GetNextSelectedItem(pos);
				user.GetUser(&m_listctrl, i);
				nom = user.prenom + " " + user.nom;
				numero = user.matricule;

				strText= "send \"" + message + "\" to ." + user.matricule + user.contexte + " > log.txt";
			}
			else
			{
				i = m_grplist.GetNextSelectedItem(pos);
				numero = m_grplist.GetItemText(i,1);
				nom = m_grplist.GetItemText(i,0);
				vrai_context = m_grplist.GetItemText(i,2);

				strText= "send \"" + message + "\" to ." + numero + vrai_context + " > log.txt";
			}
			system(strText);

			texte=strText + " ("+ nom +")";
			UpdateData(false);

		    _strtime( tmpbuf );
			_strdate( tmpbuf2 );

			strText.Format ( "[%s %s] <%7s>: %s\r\n", tmpbuf2, tmpbuf, numero, message);
			fprintf(f, strText);
			Transform (strText, false);
			if (userpref.bPlusBas) m_histo += strText;

			FILE *f2;
			texte = "";

			f2=fopen("log.txt", "rt");
			if (f2)
			{
				fgets(chaine, 254, f2);
				while(!feof(f2))
				{
					texte=chaine;
					fgets(chaine, 254, f2);
				}
				fclose(f2);
				Transform (texte, true);

				if (listselect)
				{
					if (texte.Find("t envoy", 0) != -1)
					{
						m_listctrl.SetItem(i, 0, LVIF_TEXT | LVIF_IMAGE, numero, 0,0,0,NULL);
						sprintf(tmp, "%d", 0);
						m_listctrl.SetItem(i, 4, LVIF_TEXT, tmp, 0,0,0,NULL);
					}
					else
					{
						m_listctrl.SetItem(i, 0, LVIF_TEXT, numero, 1,0,0,NULL);
						sprintf(tmp, "%d", 1);
						m_listctrl.SetItem(i, 4, LVIF_TEXT, tmp, 1,0,0,NULL);
					}
					m_listctrl.Update(i);
					DDX_Control(&DX, IDC_LIST1, m_listctrl);
				}
				else
				{
					if (texte.Find("t envoy", 0) != -1)
					{
						m_grplist.SetItem(i, 0, LVIF_TEXT | LVIF_IMAGE, nom, 0,0,0,NULL);
					}
					else
						m_grplist.SetItem(i, 0, LVIF_TEXT | LVIF_IMAGE, nom, 1,0,0,NULL);
					m_grplist.Update(i);
					DDX_Control(&DX, IDC_GRPLIST, m_grplist);
				}
			}
		}
		fclose(f);

		message.Empty();
		DDX_Text(&DX, texte1, texte);
		DDX_Text(&DX, IDC_EDIT1, message);
		DDX_Text(&DX, IDC_HISTORIQUE, m_histo);
		if (userpref.bPlusBas) 
			m_histo_ctrl.LineScroll( m_histo_ctrl.GetLineCount(), 0);
	}

}

void CSearchDlg::Lister()
{
	int nbmatricule=0, nbTous=0;

	const CString sepUser = "Utilisateur:",
			      sepLastName = "Nom de famille:",
			      sepGivenName = "Prnom:", 
			      sepContexte = "Contexte actuel : ";
	const UINT NBCHLIGNEF = 40;
	User user;
	char s[NBCHLIGNEF + 1];
	char node[20];
	char *ps;

	CDataExchange DX (this, false);

	UINT localui = local.GetCurSel();
	CLocal *pLocal = cegep.TrouveLocal(localui);
	UINT LOCALTOUS = local.GetCount() - 1;

	CString vrai_context = GetContext();
	if (vrai_context.IsEmpty())
		system("f:\\public\\nlist.exe user show \"Prnom\" \"Nom de famille\" \"Adresse de rseau\" /a  /s /co \".st_jerome\" > list.txt");
	else
		system("f:\\public\\nlist.exe user show \"Prnom\" \"Nom de famille\" \"Adresse de rseau\" /a /co \"" + vrai_context + "\" > list.txt");

	FILE *f;
	bool fichierouvert = true;
	f=fopen("list.txt", "r");
	if (!f)
	{
		fichierouvert = false;
		texte = "Erreur d'ouverture !";
		DDX_Text(&DX, texte1, texte);
	}
	else
		fgets(s, NBCHLIGNEF, f);

	
	while (!feof(f))
	{
		while(!feof(f) && !strstr(s,sepUser)) 
		{
			if (!feof(f) && strstr(s, sepContexte))
			{
				s[strlen(s)-1]='\0';
				ps=&s[sepContexte.GetLength()];
				vrai_context =  ".";
				vrai_context += ps;
			}
			fgets(s, NBCHLIGNEF, f);
		}
		
		if (!feof(f)) 
		{
			// matricule (user: )
			s[strlen(s)-1]='\0';
			ps=&s[1+sepUser.GetLength()];
			
			user.matricule = ps;

			if (user.matricule == infoperso.matricule)
				user.status = 3;
			else
				user.status = 2;

			// nom  (last name: )
			// 2::ESPACE + "|"...
			
			fgets(s, NBCHLIGNEF,f);
			s[strlen(s)-1]='\0';
			ps=&s[2+sepLastName.GetLength()];
			
			user.nom = ps;
			user.contexte = vrai_context;
			
			// prenom (given name:) 
			fgets(s, NBCHLIGNEF,f);
			user.prenom.Empty();
			if (strstr(s, sepGivenName))
			{
				s[strlen(s)-1]='\0';
				ps=&s[2+sepGivenName.GetLength()];
	
				user.prenom = ps;
				fgets(s, NBCHLIGNEF, f);
			}

			while(!feof(f) && 
				!strstr(s,"IP:") &&
				!strstr(s,sepUser) && 
				!strstr(s,"Rseau:") &&
				!strstr(s,sepContexte) ) 
			{

				while(!feof(f) && 
					!strstr(s,"IP:") &&
					!strstr(s,sepUser) && 
					!strstr(s,"Rseau:") &&
					!strstr(s,sepContexte)) 
					fgets(s, 40, f);

				//		Adresse IP: 172.20.11.48			
				user.node.Empty();
				if (strstr(s, "IP:")) 
				{
					s[strlen(s)-1]='\0';
					sprintf(node,"%s", &s[14]);
					user.node = node;
				}
				/*
					Adresse de rseau: 
					Adresse du rseau IPX/SPX
					Rseau: 10
					Noeud: 2B304FDD9
					Socket: 4014
				*/
				if (strstr(s, "Rseau:")) 
				{
					s[strlen(s)-1]='\0';
					sprintf(node,"%s:", &s[10]);
			
					fgets(s, NBCHLIGNEF, f);
					s[strlen(s)-1]='\0';
					ps=&s[9];
					strcat(node,ps);
					
					user.node = node;
				}

				if(!feof(f) && !strstr(s,sepUser) && user.node!="" )
				{
					nbTous++;
					cegep.SetOrdiUser(user.node, user);
					if (localui != LOCALTOUS)
					{
						if (pLocal && pLocal->OrdiDansLocal(user.node)) 
							user.AjouterListe(&m_listctrl,nbmatricule++);
					}
					else
						user.AjouterListe(&m_listctrl,nbmatricule++);
					
					if (strchr(node, '.')) 
						fgets(s, NBCHLIGNEF, f);
				}
			}
		}
	}
	
	if (f) 
		fclose(f); 

	EtatGrp();
	texte.Format(_T("Nombre d'utilisateur(s): %d / %d"), nbmatricule, nbTous);
	{
		DDX_Text(&DX, texte1, texte);
		DDX_Control(&DX, IDC_GRPLIST, m_grplist);
		DDX_Control(&DX, IDC_LIST1, m_listctrl);
	}

	//if (userpref.bPlusBas) 
	//	m_histo_ctrl.LineScroll( m_histo_ctrl.GetLineCount(), 0);

	vrai_context.FreeExtra();

}

void CSearchDlg::OnOK() 
{
	// TODO: Add extra validation here
	
	CDialog::OnOK();
}

void CSearchDlg::OnBtnClickMiseAJour() 
{
	// TODO: Add your control notification handler code here
    m_listctrl.DeleteAllItems();
    Lister();
}

void CSearchDlg::OnChkRecevoirOnOff() 
{
	// TODO: Add your control notification handler code here
	if ( send == false )
	{
		system("f:\\public\\send.exe /a > log.txt");
		send = true;
	}
	else {
		send = false;
		system("f:\\public\\send.exe /a=n > log.txt");
	}	
	
	FILE *f; 
	char chaine[255];
	texte = "";
	f=fopen("log.txt", "rt");
	fgets(chaine, 254, f);
	while(!feof(f))
	{
		texte+=chaine;
		fgets(chaine, 254, f);
	}
	fclose(f);

	Transform(texte);
	UpdateData(false);
	if (userpref.bPlusBas) m_histo_ctrl.LineScroll( m_histo_ctrl.GetLineCount(), 0);

}


void CSearchDlg::cmdTrouver_Click() 
{
	// TODO: Add your control notification handler code here
	CString strText, 
		numero;
	int i;

	POSITION pos = m_listctrl.GetFirstSelectedItemPosition();
	UpdateData(true);
	
	while (pos)
	{
		i = m_listctrl.GetNextSelectedItem(pos);
		numero = m_listctrl.GetItemText(i,3);
		
		strText = cegep.TrouveOrdi(numero);
		if (strText == "")
		{
			strText = "Pas trouv";
		}

		texte=strText;
		UpdateData(false); 

		if (userpref.bPlusBas) 
			m_histo_ctrl.LineScroll( m_histo_ctrl.GetLineCount(), 0);
	}
	
}

void CSearchDlg::OnClickSurPlus() 
{
	// TODO: Add your control notification handler code here
	CRect rect;
	GetWindowRect(rect);
	CRect rect2;
	
	CPoint plus (position.left, position.top);

	if (userpref.bPlusDroite)	plus.x = position.right;
	if (!userpref.bPlusBas)		plus.y = position.bottom;
	rect2.SetRect(rect.left, rect.top, rect.left+plus.x, rect.top+plus.y);

	MoveWindow(rect2, TRUE);
	if (userpref.bPlusBas) 
	{
		userpref.bPlusBas = false;
	}
	else
	{
		userpref.bPlusBas = true;
		EcrireHisto();
	}
}

void CSearchDlg::OnPlusdroite() 
{
	// TODO: Add your control notification handler code here
	CRect rect;
	GetWindowRect(rect);
	CRect rect2;
	
	CPoint plus (position.left, position.top);

	if (!userpref.bPlusDroite)    plus.x = position.right;
	if (userpref.bPlusBas) plus.y = position.bottom;
	rect2.SetRect(rect.left, rect.top, rect.left+plus.x, rect.top+plus.y);

	MoveWindow(rect2, TRUE);
	(userpref.bPlusDroite)?userpref.bPlusDroite=false:userpref.bPlusDroite=true;
}

CString CSearchDlg::ChercheContext()
{
	if (lecontext.Find("420",0) != -1)  return _T(".420.ST_JEROME");
	if (lecontext.Find("140",0) != -1)  return _T(".140.ST_JEROME");
	if (lecontext.Find("241",0) != -1)  return _T(".241.ST_JEROME");
	if (lecontext.Find("243",0) != -1)  return _T(".243.ST_JEROME");
	if (lecontext.Find("410",0) != -1)  return _T(".410.ST_JEROME");
	if (lecontext.Find("582",0) != -1)  return _T(".582.ST_JEROME");
	if (lecontext.Find("999",0) != -1)  return _T(".999.ST_JEROME");
	if (lecontext.Find("Prof",0) != -1) return _T(".PROFESSEURS.ST_JEROME");
	return "";
}

CString CSearchDlg::GetContext()
{
	int gcs;
	gcs = context.GetCurSel();

	if (gcs == -1) 
	{
		CString findstr = infoperso.context.Mid(1,3);
		if ( findstr.Find("PROF", 0) == -1 ) findstr = "(" + findstr;
		if( (gcs = context.FindString( -1, findstr )) == CB_ERR )
			gcs = 0;
		context.SetCurSel( gcs );
		return (infoperso.context);
	}
	else
	{
		context.GetLBText(gcs, lecontext);
		return ChercheContext();
	}
}

void CSearchDlg::EcrireHisto()
{
	char chaine[255];
	CString string = _T("");

	FILE *f;
	f=fopen("journal.log", "rt");
	if (f) 
	{
		fgets(chaine, 254, f);
		while(!feof(f))
		{
			string+=chaine;
			fgets(chaine, 254, f);
		}
		fclose(f);
	
	}
	string.AnsiToOem();
	m_histo = string;
	CDataExchange DX(this,false);
	DDX_Text(&DX, IDC_HISTORIQUE, m_histo);
	m_histo_ctrl.LineScroll( m_histo_ctrl.GetLineCount(), 0);
}

void CSearchDlg::OnBtnSupprimerhisto() 
{
	// TODO: Add your control notification handler code here
	FILE *f;
	f=fopen("journal.log", "wt");
	if (f) 
	{
		fclose(f);
	}

	m_histo.Empty();
	CDataExchange DX(this,false);
	DDX_Text(&DX, IDC_HISTORIQUE, m_histo);
}

void CSearchDlg::OnColumnclickList1(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_LISTVIEW* pNMListView = (NM_LISTVIEW*)pNMHDR;
	// TODO: Add your control notification handler code here

	int n = m_listctrl.GetItemCount();
	int s = pNMListView->iSubItem;
	int iSubItem;
	int j, indic;
	int tmpi1, tmpi2;
	CString tmp;

	for (int i = 0; i < n-1; i++)
	{
		j=i;
			for (j=i+1, indic=i; j<n; j++)
				if (m_listctrl.GetItemText( j, s) < m_listctrl.GetItemText( indic, s))
					indic = j;
		if (indic!=i)
		{
			for (iSubItem=0; iSubItem < 6; iSubItem++) 
			{
				tmp = m_listctrl.GetItemText( indic, iSubItem);
				m_listctrl.SetItemText( indic, iSubItem, m_listctrl.GetItemText( i, iSubItem));
				m_listctrl.SetItemText( i, iSubItem, tmp);
			}
			
			sscanf(m_listctrl.GetItemText(i, 4),    "%d", &tmpi1);
			sscanf(m_listctrl.GetItemText(indic, 4),"%d", &tmpi2);

			m_listctrl.SetItem(i, 0, LVIF_TEXT | LVIF_IMAGE, m_listctrl.GetItemText( i, 0), tmpi1 ,0,0,NULL);
			m_listctrl.SetItem(indic, 0, LVIF_TEXT | LVIF_IMAGE, m_listctrl.GetItemText( indic, 0), tmpi2 ,0,0,NULL);

		}
	}

	CDataExchange DX(this,false);
	DDX_Control(&DX, IDC_LIST1, m_listctrl);
	*pResult = 0;
}

void CSearchDlg::OnInitList()
{
	CSearchApp     *pApp = (CSearchApp *)AfxGetApp();

	CImageList *m_pImageList = new CImageList();
	CImageList *m_pImageListGrp = new CImageList();
	
	ASSERT(m_pImageList != NULL);    // serious allocation failure checking
	ASSERT(m_pImageListGrp != NULL);    // serious allocation failure checking

	// insertion des icones...
	m_pImageList->Create(16, 16, TRUE,  0, 4);
	m_pImageList->Add(pApp->LoadIcon(IDI_USERONLINE));
	m_pImageList->Add(pApp->LoadIcon(IDI_USEROFFLINE));
	m_pImageList->Add(pApp->LoadIcon(IDI_USERUNKNOWN));
	m_pImageList->Add(pApp->LoadIcon(IDI_USERME));

	m_pImageListGrp->Create(16, 16, TRUE,  0, 5);
	m_pImageListGrp->Add(pApp->LoadIcon(IDI_USERONLINE));
	m_pImageListGrp->Add(pApp->LoadIcon(IDI_USEROFFLINE));
	m_pImageListGrp->Add(pApp->LoadIcon(IDI_USERUNKNOWN));
	m_pImageListGrp->Add(pApp->LoadIcon(IDI_USERGRPONLINE));
	m_pImageListGrp->Add(pApp->LoadIcon(IDI_USERGRPOFFLINE));

	// application de la liste des icones
	m_listctrl.SetImageList(m_pImageList, LVSIL_SMALL);
	m_grplist.SetImageList(m_pImageListGrp, LVSIL_SMALL);
	
	// insertion des entetes de colonnes

	m_grplist.InsertColumn(0,"NOM",LVCFMT_LEFT, 80, 0);
	m_grplist.InsertColumn(1,"MATRICULE",LVCFMT_LEFT, 130, 1);
	m_grplist.InsertColumn(2,"CONTEXT",LVCFMT_LEFT, 130, 1);

	m_listctrl.InsertColumn(0,"MATRICULE",LVCFMT_LEFT, 80, 0);
	m_listctrl.InsertColumn(1,"PRENOM",LVCFMT_LEFT, 130, 1);
	m_listctrl.InsertColumn(2,"NOM",LVCFMT_LEFT, 170, 2);
	m_listctrl.InsertColumn(3,"NODE/IP",LVCFMT_LEFT, 150, 3);
	m_listctrl.InsertColumn(4,"IMAGE",LVCFMT_LEFT, 0, 4);
	m_listctrl.InsertColumn(5,"CONTEXTE",LVCFMT_LEFT, 0, 5);
}

void Transform(CString &str, bool diff/* = true*/)
{
	str.Replace("", "");
	str.Replace("", "");
	str.Replace("", "");
	str.Replace("", "");
	if (diff) str.Replace("\n", " ");
}

void CSearchDlg::OnGrpplus() 
{
	// TODO: Add your control notification handler code here
	CString numero;
	int i;
	
	POSITION pos = m_listctrl.GetFirstSelectedItemPosition();
	CDataExchange DX(this,true);
	DDX_Control(&DX, IDC_GRPLIST, m_grplist);

	char chaine[255];
	CString nom;
	LVITEM lv;
	int nb;
	User user;

	while (pos)
	{
		i = m_listctrl.GetNextSelectedItem(pos);
		nb = m_grplist.GetItemCount();
		user.GetUser(&m_listctrl, i);

		lv.mask = LVIF_TEXT | LVIF_IMAGE | LVIF_PARAM;

		lv.iImage=3;
		lv.iItem=nb;
		lv.iSubItem=0;
		lv.lParam = i;
		strcpy(chaine, user.nom);
		strcat(chaine, " ");
		strcat(chaine, user.prenom);

		lv.pszText = chaine;
		m_grplist.InsertItem(&lv); // insert new item
		
		lv.mask = LVIF_TEXT;
		lv.iSubItem=1;
		strcpy(chaine, user.matricule);
		lv.pszText = chaine;
		m_grplist.SetItem(&lv);

		lv.iSubItem=2;
		strcpy(chaine, user.contexte);
		lv.pszText = chaine;
		m_grplist.SetItem(&lv);
	}

	DX.m_bSaveAndValidate = false;
	DDX_Control(&DX, IDC_GRPLIST, m_grplist);
}

void CSearchDlg::OnGrpmoins() 
{
	// TODO: Add your control notification handler code here
	POSITION pos = m_grplist.GetFirstSelectedItemPosition();

	CDataExchange DX(this,false);
	int i;
	while (pos)
	{
		i = m_grplist.GetNextSelectedItem(pos);
		m_grplist.DeleteItem(i);
		DDX_Control(&DX, IDC_GRPLIST, m_grplist);
		pos = m_grplist.GetFirstSelectedItemPosition();
	}
}

void CSearchDlg::OnSetfocusListCtrl(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// TODO: Add your control notification handler code here
	listselect = true;
	*pResult = 0;
}

void CSearchDlg::OnSetfocusGrplist(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// TODO: Add your control notification handler code here
	listselect = false;
	*pResult = 0;
}

void CSearchDlg::GrpListCharger()
{
	char numero[255],
		    nom[255], 
			context[255];
	char chaine[255];
	int nb;
	FILE *f;

	char *pdest, *pdest2;
	int  result, result1;

	f = fopen ("groupe.ini", "rt");
	LVITEM lv;
	if (f)
		fgets(chaine, 254, f);
	while (f && !feof(f))
	{
		pdest = strstr(chaine, ":");
		result1 = pdest - chaine;

		if (pdest)
		{
			strncpy(nom, chaine, result1);
			nom[result1] = '\0';
			pdest2 = strstr(++pdest, ":");
			if (pdest2)
			{
				result = pdest2 - pdest;
				strncpy(numero, pdest, result);
				numero[result] = '\0';
				strcpy(context, ++pdest2);
				context[strlen(pdest2)-1] ='\0';
			}
		}

		nb = m_grplist.GetItemCount();

		lv.mask = LVIF_TEXT | LVIF_IMAGE | LVIF_PARAM;
		lv.iImage=2;
		lv.iItem=nb;
		lv.iSubItem=0;
		lv.pszText = nom;
		m_grplist.InsertItem(&lv); // insert new item
		
		lv.mask = LVIF_TEXT;
		lv.iSubItem=1;
		lv.pszText = numero;
		m_grplist.SetItem(&lv);

		lv.iSubItem=2;
		lv.pszText = context;
		m_grplist.SetItem(&lv);

		fgets(chaine, 254, f);

	}

	if (f) fclose(f);
}

void CSearchDlg::GrpListEcrire()
{
	FILE *f;
	int i, j;
	f = fopen("groupe.ini", "wt");
	for (i=0; i<m_grplist.GetItemCount(); i++)
	{
		for (j=0; j<3; j++)
		{
			fprintf(f, "%s", m_grplist.GetItemText(i,j));
			if (j!=2) fputc(':', f);
			else fputc('\n',f);
		}
	}
	if (f) fclose(f);
}

void CSearchDlg::OnBtnSauvegarder() 
{
	// TODO: Add your control notification handler code here
	GrpListEcrire();
}


void CSearchDlg::OnInitLocaux()
{
	cegep.LireXML();

	/*cegep.InsereLocal(0, CLocal("C246", "172.19.11",25));
	cegep.local[0].InitLocal(1, "44",  25,250);
	cegep.local[0].InitLocal(2, "149", 75,250);
	cegep.local[0].InitLocal(3, "55", 125,250);
	cegep.local[0].InitLocal(4, "95", 175,250);
	cegep.local[0].InitLocal(5, "106",225,250);
	cegep.local[0].InitLocal(6, "148",275,250);
	cegep.local[0].InitLocal(7, "67" ,300,175);
	cegep.local[0].InitLocal(8, "75" ,250,175);
	cegep.local[0].InitLocal(9, "49" ,200,175);
	cegep.local[0].InitLocal(10,"48", 150,175);
	cegep.local[0].InitLocal(11,"54", 100,175);
	cegep.local[0].InitLocal(12,"22",  50,175);
	cegep.local[0].InitLocal(13,"203", 50,125);
	cegep.local[0].InitLocal(14,"234",100,125);
	cegep.local[0].InitLocal(15,"93" ,150,125);
	cegep.local[0].InitLocal(16,"19" ,200,125);
	cegep.local[0].InitLocal(17,"154",250,125);
	cegep.local[0].InitLocal(18,"164",300,125);
	cegep.local[0].InitLocal(19,"34" ,275, 50);
	cegep.local[0].InitLocal(20,"182",225, 50);
	cegep.local[0].InitLocal(21,"180",175, 50);
	cegep.local[0].InitLocal(22,"233",125, 50);
	cegep.local[0].InitLocal(23,"210", 75, 50);
	cegep.local[0].InitLocal(24,"45" , 25, 50);
	cegep.local[0].InitLocal(25,"25", 350,150);
	cegep.local[0].ordi[25].NodeHaut = "172.19.246";


	cegep.InsereLocal(1, CLocal("C254", "172.21.1",12));
	cegep.local[1].InitLocal(10,"151",125, 25);
	cegep.local[1].InitLocal(4,"20", 175, 25);
	cegep.local[1].InitLocal(1,"250", 225, 25);
	cegep.local[1].InitLocal(2,"190", 275, 25);
	cegep.local[1].InitLocal(5,"112", 330, 75);
	cegep.local[1].InitLocal(6,"215", 330, 125);
	cegep.local[1].InitLocal(7,"194", 330, 175);
	cegep.local[1].InitLocal(8,"197", 330, 225);
    cegep.local[1].InitLocal(9, "135", 25, 210);
	cegep.local[1].InitLocal(11,"41", 75, 150);
	cegep.local[1].ordi[11].NodeHaut = "172.21.2";
	cegep.local[1].InitLocal(12,"89", 75, 200);

	cegep.InsereLocal(2, CLocal("D247", "172.21.1",25));
	cegep.local[2].InitLocal( 1,"236", 75,275);
	cegep.local[2].InitLocal( 2,"227",125,275);
	cegep.local[2].InitLocal( 3,"230",175,275);
	cegep.local[2].InitLocal( 4, "66",225,225);
	cegep.local[2].InitLocal( 5,"58",175,225);
	cegep.local[2].ordi[5].NodeHaut = "172.21.2";
	cegep.local[2].InitLocal( 6, "67",125,225);
	cegep.local[2].ordi[6].NodeHaut = "172.21.2";
	cegep.local[2].InitLocal( 7, "11", 75,225);
	cegep.local[2].InitLocal( 8,  "5", 75,150);
	cegep.local[2].InitLocal( 9, "26",125,150);
	cegep.local[2].ordi[9].NodeHaut = "172.21.2";
	cegep.local[2].InitLocal(10,"60", 175,150);
	cegep.local[2].ordi[10].NodeHaut = "172.21.2";
	cegep.local[2].InitLocal(11,"139",225,150);
	cegep.local[2].InitLocal(12, "28",275,150);
	cegep.local[2].InitLocal(13,"140",275,100);
	cegep.local[2].InitLocal(14,"205",225,100);
	cegep.local[2].InitLocal(15,"245",175,100);
	cegep.local[2].InitLocal(16,"108",125,100);
	cegep.local[2].InitLocal(17,"196", 75,100);
	cegep.local[2].InitLocal(18,"107", 75, 25);
	cegep.local[2].InitLocal(19, "96",125, 25);
	cegep.local[2].InitLocal(20,"202",175, 25);
	cegep.local[2].InitLocal(21,"167",125, 25);
	cegep.local[2].InitLocal(22, "63",275, 25);
	cegep.local[2].InitLocal(23,"110",325, 25);
	cegep.local[2].InitLocal(24,"217",375, 25);
	cegep.local[2].InitLocal(25,"235",25,125);

	cegep.InsereLocal(3, CLocal("D341", "172.19.11",25));
	cegep.local[3].InitLocal(1, "242" ,375,  50);
	cegep.local[3].InitLocal(2, "129",325,  50);
	cegep.local[3].InitLocal(3, "178" ,275,  50);
	cegep.local[3].InitLocal(4, "92" ,225,  50); // ok
	cegep.local[3].InitLocal(5, "195",175,  50); // ok
	cegep.local[3].InitLocal(6, "230",125,  50); // ok
	cegep.local[3].InitLocal(7, "151", 75,  50); // ok
	cegep.local[3].InitLocal(8, "61" , 75, 100); // ok
	cegep.local[3].InitLocal(9, "15" ,125, 100); // ok
	cegep.local[3].InitLocal(10,"207",175, 100); // ok
	cegep.local[3].InitLocal(11,"165",225, 100); // ok
	cegep.local[3].InitLocal(12,"150",275, 100); // ok
	cegep.local[3].InitLocal(13,"147",325, 100); // ok
	cegep.local[3].InitLocal(14,"200",375, 100); // ok
	cegep.local[3].InitLocal(15,"144",475, 175); // ok
	cegep.local[3].InitLocal(16,"219",425, 175); // ok
	cegep.local[3].InitLocal(17,"222",375, 175); // ok
	cegep.local[3].InitLocal(18,"88" ,325, 175); // ok
	cegep.local[3].InitLocal(19,"26" ,275, 175); // ok
	cegep.local[3].InitLocal(20,"218",225, 175); // ok
	cegep.local[3].InitLocal(21,"205",175, 175); // ok
	cegep.local[3].InitLocal(22,"229",125, 175); // ok
	cegep.local[3].InitLocal(23,"43" , 75, 175); // ok
	cegep.local[3].InitLocal(24,"143", 25, 175); // ok
	cegep.local[3].InitLocal(25,"12" , 20,  75); // ok

	//20523711:6097D137FC : A313 : Gestion des labo (new 3c90x)
    // local node ok, position non, numero au hasard...
	cegep.InsereLocal(4, CLocal("A312", "20523712",24));
	cegep.local[4].InitLocal(1,"50047C4522");
	cegep.local[4].InitLocal(2,"50047C449E");
	cegep.local[4].InitLocal(3,"50047C4511");
	cegep.local[4].InitLocal(4,"50047C44F6");
	cegep.local[4].InitLocal(5,"50047C44E3");
	cegep.local[4].InitLocal(6,"50047C44E0");
	cegep.local[4].InitLocal(7,"50047C4510");
	cegep.local[4].InitLocal(8,"50047C44F4");
	cegep.local[4].InitLocal(9,"50047C4520");
	cegep.local[4].InitLocal(10,"50047B00C9");
	cegep.local[4].InitLocal(11,"50047C4515");
	cegep.local[4].InitLocal(12,"50047C450F");
	cegep.local[4].InitLocal(13,"50047C451E");
	cegep.local[4].InitLocal(14,"50047C4496");
	cegep.local[4].InitLocal(15,"50047B00CA");
	cegep.local[4].InitLocal(16,"50047C450C");
	cegep.local[4].InitLocal(17,"50047C4521");
	cegep.local[4].InitLocal(18,"50047C44AA");
	cegep.local[4].InitLocal(19,"50047C2D70");
	cegep.local[4].InitLocal(20,"50047C44F5");
	cegep.local[4].InitLocal(21,"50047C2D87");
	cegep.local[4].InitLocal(22,"50047C451F");
	cegep.local[4].InitLocal(23,"50047C44CE");
	cegep.local[4].InitLocal(24,"50047C4517");

    // local node ok, position non, numero ok...
	cegep.InsereLocal(5, CLocal("D125", "205237111",12));
	cegep.local[5].InitLocal(1, "5004746CD3");
	cegep.local[5].InitLocal(2,"5004109137");
	cegep.local[5].InitLocal(3,"5004107CE8");
	cegep.local[5].InitLocal(4,"5004109445");
	cegep.local[5].InitLocal(5,"500410943E");
	cegep.local[5].InitLocal(6,"50041094E7");
	cegep.local[5].InitLocal(7,"104B6294A8");
	cegep.local[5].InitLocal(8,"104B6294C7");
	cegep.local[5].InitLocal(9,"105A1D91A4");
	cegep.local[5].InitLocal(10,"104B63E705");
	cegep.local[5].InitLocal(11,"104B732704");
	cegep.local[5].InitLocal(12,"104B62948D");

    // local node ok, position non, numero ok...
	cegep.InsereLocal(6, CLocal("D319", "13",22));
	cegep.local[6].InitLocal(1,"50047C4498");
	cegep.local[6].InitLocal(2,"50047B0000");
	cegep.local[6].InitLocal(3,"50047C4487");
	cegep.local[6].InitLocal(4,"50047C449C");
	cegep.local[6].InitLocal(5,"50047C44FD");
	cegep.local[6].InitLocal(6,"50047C2DAB");
	cegep.local[6].InitLocal(7,"50047C44FA");
	cegep.local[6].InitLocal(8,"50047C44FB");
	cegep.local[6].InitLocal(9,"50047AFFFF");
	cegep.local[6].InitLocal(10,"50047C44A5");
	cegep.local[6].InitLocal(11,"50047C44F7");
	cegep.local[6].InitLocal(12,"50047C2D95");
	cegep.local[6].InitLocal(13,"50047C2DA9");
	cegep.local[6].InitLocal(14,"50047C44E4");
	cegep.local[6].InitLocal(15,"50047B00FA");
	cegep.local[6].InitLocal(16,"50047B0002");
	cegep.local[6].InitLocal(17,"50047C44E2");
	cegep.local[6].InitLocal(18,"50047AFFE3");
	cegep.local[6].InitLocal(19,"50047C44F9");
	cegep.local[6].InitLocal(20,"50047C2DB0");
	cegep.local[6].InitLocal(21,"50047C44B6");
	cegep.local[6].InitLocal(22,"5003447C4044");

	cegep.InsereLocal(7, CLocal("D253", "172.21.1",23));
	cegep.local[7].InitLocal(23,"87", 275, 25);

	cegep.InsereLocal(8, CLocal("Biblio", "172.21.1",27));
	cegep.local[8].InitLocal(13,"161", 125, 290);
	cegep.local[8].InitLocal(18,"97", 175, 250);
	cegep.local[8].InitLocal(5,"123", 75, 250);
	cegep.local[8].InitLocal(15,"98", 100, 200);
	cegep.local[8].InitLocal(16,"249", 150, 200);

	cegep.local[8].InitLocal(7,"", 350, 235);
	cegep.local[8].InitLocal(8,"", 300, 235);
	cegep.local[8].InitLocal(9 ,"", 275, 185);
	cegep.local[8].InitLocal(10,"", 325, 150);
	cegep.local[8].InitLocal(11,"", 375, 185);

	cegep.local[8].InitLocal(27,"14", 25, 150);
	cegep.local[8].ordi[27].NodeHaut = "172.21.2";
	cegep.local[8].InitLocal(26,"27", 75, 120);
	cegep.local[8].ordi[26].NodeHaut = "172.21.2";
	cegep.local[8].InitLocal(25,"218", 25, 100);

	cegep.local[8].InitLocal(6,"121", 400, 25);
	cegep.local[8].InitLocal(3,"", 350, 50);
	cegep.local[8].InitLocal(4,"44", 400, 75);

	cegep.local[8].InitLocal(19,"", 250, 100);
	cegep.local[8].InitLocal(20,"", 250, 50);
	cegep.local[8].InitLocal(21 ,"",200, 25);
	cegep.local[8].InitLocal(22,"", 150, 50);
	cegep.local[8].InitLocal(23,"", 150, 100);
	cegep.local[8].InitLocal(24,"", 200, 125);*/
	
	cegep.Lister(&local);
	local.AddString("Tous");
	local.SetCurSel(local.GetCount()-1);
}

void CSearchDlg::OnInitInterface()
{
	OnClickSurPlus();
	OnPlusdroite();
    m_listctrl.SetTextBkColor( userpref.TextBkColor );
	m_listctrl.SetTextColor( userpref.TextColor );
	m_listctrl.SetBkImage( userpref.ImageURi, TRUE);
}

#include "DlgUserPref.h"
void CSearchDlg::OnPreference() 
{
	// TODO: Add your command handler code here
	CDlgUserPref dlg(&userpref);
	if (dlg.DoModal() == IDOK)
	{
	    m_listctrl.SetTextBkColor( userpref.TextBkColor );
		m_listctrl.SetTextColor( userpref.TextColor );
		m_listctrl.SetBkImage( userpref.ImageURi, TRUE);

		CDataExchange DX(this,false);
		DDX_Control(&DX, IDC_LIST1, m_listctrl);
		UpdateData(false);
	}
}

void CSearchDlg::OnEndlabeleditGrplist(NMHDR* pNMHDR, LRESULT* pResult) 
{
	LV_DISPINFO* pDispInfo = (LV_DISPINFO*)pNMHDR;
	// TODO: Add your control notification handler code here
	
	m_grplist.SetItem(&pDispInfo->item);

		
	*pResult = 0;
}

void CSearchDlg::OnPointinterrogation() 
{
	// TODO: Add your command handler code here
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
}

#include "DlgPlan.h"
void CSearchDlg::OnMnuplan() 
{
	// TODO: Add your command handler code here
	CDlgPlan dlg(&cegep);
	if (dlg.DoModal()==IDOK)
	{
		if (!dlg.user.IsEmpty())
		{
			listselect = true;
			TrouverUsager(dlg.user.matricule, 0);
		}
	}

}


#include "DlgRechercher.h"
void CSearchDlg::OnMnuRechercher() 
{
	// TODO: Add your command handler code here
	CDlgRechercher dlg;
	if (dlg.DoModal()==IDOK)
	{
		if ( dlg.m_Matricule != "")
		{
			TrouverUsager(dlg.m_Matricule, 0);
		}
	}
}

bool CSearchDlg::TrouverUsager(CString string, UINT colonne)
{
	int nIndex;
	LVFINDINFO info;
	info.flags = LVFI_PARTIAL|LVFI_STRING|LVFI_WRAP;
	info.psz = string;
	nIndex = m_listctrl.FindItem(&info);
	if (nIndex !=-1)
	{
		for (int i=0; i<m_listctrl.GetItemCount( ); i++)
		if (i == nIndex) m_listctrl.SetItemState(i, LVIS_SELECTED, LVIS_SELECTED);
		else             m_listctrl.SetItemState(i, LVIS_ACTIVATING, LVIS_SELECTED);
		m_listctrl.EnsureVisible(nIndex, FALSE);
		GotoDlgCtrl( GetDlgItem(IDC_EDIT1) );
		return true;
	}
	return false;
}

void CSearchDlg::EtatGrp()
{
	LVFINDINFO info;
	info.flags = LVFI_PARTIAL|LVFI_STRING|LVFI_WRAP;
	CString str;
	for (int i=0; i<m_grplist.GetItemCount(); i++)
	{
		str = m_grplist.GetItemText(i,1);
		info.psz  = str;

		if (m_listctrl.FindItem(&info) != -1)
			m_grplist.SetItem(i, 0, LVIF_TEXT | LVIF_IMAGE, m_grplist.GetItemText(i,0), 3,0,0,NULL);
		else
			m_grplist.SetItem(i, 0, LVIF_TEXT | LVIF_IMAGE, m_grplist.GetItemText(i,0), 4,0,0,NULL);
	}
}
