// User.cpp: implementation of the User class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "search.h"
#include "User.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

User::User()
{
	status = 2;
}

User::User(User &user)
{
	*this = user;
}

User::~User()
{

}

void User::AjouterListe(CListCtrl *m_listctrl, int i)
{
	char temp[256];
	LVITEM lv;

	lv.mask = LVIF_TEXT | LVIF_IMAGE | LVIF_PARAM;
	
	lv.iImage=status;
	lv.iItem=i;
	lv.iSubItem=0;
	lv.lParam = i;

	strcpy(temp,matricule);
	lv.pszText = temp;
	m_listctrl->InsertItem(&lv); // insert new item


		
	lv.mask = LVIF_TEXT;
	lv.iSubItem=2;
	strcpy(temp,nom);
	lv.pszText = temp;
	m_listctrl->SetItem(&lv);

	lv.iSubItem=1;
	strcpy(temp,prenom);
	lv.pszText = temp;
	m_listctrl->SetItem(&lv);
		
	lv.iSubItem=3;
	strcpy(temp,node);
	lv.pszText = temp;
	m_listctrl->SetItem(&lv);

	lv.iSubItem=4;
	sprintf(temp, "%d", status);
	lv.pszText = temp;
	m_listctrl->SetItem(&lv);

	lv.iSubItem=5;
	strcpy(temp, contexte);
	lv.pszText = temp;
	m_listctrl->SetItem(&lv);
}

User& User::operator = (User &user)
{
	matricule = user.matricule;
	node = user.node;
	nom = user.nom;
	prenom = user.prenom;
	status = user.status;
	contexte = user.contexte;
	return *this;
}

void User::Flush()
{
	matricule = _T("");
	node = _T("");
	nom = _T("");
	prenom = _T("");
	contexte = _T("");
	status = 2;
}

bool User::IsEmpty()
{
	return (matricule == "" && 
		    node == "" &&
			nom == "" &&
			prenom == "");
}

void User::GetUser(CListCtrl *pCtrlList, int iIndex)
{
	if (iIndex < pCtrlList->GetItemCount())
	{	
		matricule = pCtrlList->GetItemText(iIndex,0);
		nom       = pCtrlList->GetItemText(iIndex,1);
		prenom    = pCtrlList->GetItemText(iIndex,2);
		node      = pCtrlList->GetItemText(iIndex,3);
		//char tmp[4];
		sscanf(pCtrlList->GetItemText(iIndex,4), "%d", &status);
		contexte  = pCtrlList->GetItemText(iIndex,5);
	} 

}
