// searchDlg.h : header file
//

#if !defined(AFX_SEARCHDLG_H__E9F4D057_2EB5_11D5_A633_AF13E5DBF685__INCLUDED_)
#define AFX_SEARCHDLG_H__E9F4D057_2EB5_11D5_A633_AF13E5DBF685__INCLUDED_

#include "Cegep.h"	// Added by ClassView
#include "InfoPerso.h"	// Added by ClassView
#include "UserPref.h"	// Added by ClassView
#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/////////////////////////////////////////////////////////////////////////////
// CSearchDlg dialog

class CSearchDlg : public CDialog
{
// Construction
public:
	void EtatGrp();
	bool TrouverUsager(CString string, UINT colonne);
	UserPref userpref;
	InfoPerso infoperso;

	CRect position;

	void GrpListEcrire();
	void GrpListCharger();
	bool listselect;
    void OnInitInterface();
	void OnInitList();
	void OnInitLocaux();
    void Lister();

	void EcrireHisto();
	BOOL send;
	CCegep cegep;

	CString ChercheContext();
	CString GetContext();
	CSearchDlg(CWnd* pParent = NULL);	// standard constructor

	// Dialog Data
	//{{AFX_DATA(CSearchDlg)
	enum { IDD = IDD_SEARCH_DIALOG };
	CListCtrl	m_grplist;
	CComboBox	context;
	CComboBox   local;
	CListCtrl	m_listctrl;
	CString		texte;
	CString		message;
    CString		lecontext; 
	CString		m_histo;
	CEdit		m_histo_ctrl;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CSearchDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;
 
	// Generated message map functions
	//{{AFX_MSG(CSearchDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnBtnEnvoyer();
	afx_msg void OnBtnClickMiseAJour();
	afx_msg void OnChkRecevoirOnOff();
	afx_msg void cmdTrouver_Click();
	afx_msg void OnClickSurPlus();
	virtual void OnOK();
	afx_msg void OnBtnSupprimerhisto();
	afx_msg void OnColumnclickList1(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnGrpplus();
	afx_msg void OnGrpmoins();
	afx_msg void OnSetfocusListCtrl(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnSetfocusGrplist(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnBtnSauvegarder();
	afx_msg void OnPreference();
	afx_msg void OnEndlabeleditGrplist(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnPointinterrogation();
	afx_msg void OnPlusdroite();
	afx_msg void OnMnuplan();
	afx_msg void OnMnuRechercher();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

void Transform(CString &str, bool diff = true);

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SEARCHDLG_H__E9F4D057_2EB5_11D5_A633_AF13E5DBF685__INCLUDED_)


